--[[---------------------------------------------------------------------------
	
	Creator: x[N]ir - #4841
	This work is licensed under the Creative Commons 
	Attribution-NonCommercial-ShareAlike 4.0 International License. 
	License details: http://creativecommons.org/licenses/by-nc-sa/4.0/
	
-----------------------------------------------------------------------------]]

--[[---------------------------------------------
	join
-----------------------------------------------]]
function ATM.join( id )
	ATM.ACCOUNT_new( id )
	ATM.ACCOUNT_load( id )
end

--[[---------------------------------------------
	leave
-----------------------------------------------]]
function ATM.leave( id )
	ATM.die( id )
	ATM.ACCOUNT_save( id )
	ATM.Accounts[ id ] = nil
end

--[[---------------------------------------------
	use
-----------------------------------------------]]
function ATM.use( id, data, event, x, y )
	--> Data
	if data ~= 0 then return end

	--> Tile Position
	local tx = player( id, "tilex" )
	local ty = player( id, "tiley" )

	--> Atm Loop
	for _, atm in pairs( ATM.List ) do
		--> Used 
		if atm.user == 0 then
			--> Distance
			if ATM.MATH_dist( tx, ty, math.floor( atm.x / 32 ), 
				math.floor( atm.y / 32 ) ) <= ATM.MAX_USE_DIST then
				ATM.CORE_start( atm, id )
				break
			end 
		end
	end
end

--[[---------------------------------------------
	attack
-----------------------------------------------]]
function ATM.attack( id )
	--> ATM
	local atm = ATM.CORE_getCurrentATM( id )
	if not atm or atm.status ~= ATM.LOADED then return end

	reqcld( id, 0 )
end

--[[---------------------------------------------
	clientdata
-----------------------------------------------]]
function ATM.clientdata( id, data, data1, data2 )
	--> Data
	if data ~= 0 then return end

	local atm = ATM.CORE_getCurrentATM( id )
	ATM.CORE_process( atm, data1, data2 )
end

--[[---------------------------------------------
	die
-----------------------------------------------]]
function ATM.die( victim )
	ATM.MENU_remove( victim, true )
	--> ATM
	local atm = ATM.CORE_getCurrentATM( victim )

	if atm then
		ATM.CORE_reset( atm )
	end

	--> Timers
	if ATM.Accounts[ victim ].images[ "bar" ] then
		freetimer( "parse", 'lua imagealpha(' .. 
			ATM.Accounts[ victim ].images[ "bar" ] .. ',1)' )
	end

	freetimer( 'parse', 'lua ATM.MENU_main(' .. victim .. ')' )
	freetimer( "parse", 'lua ATM.MENU_updateLoading(' .. victim .. ')' )
	freetimer( "parse", 'lua ATM.MENU_remove(' .. victim .. ',true)' )
	freetimer( "parse", "lua ATM.die(" .. victim .. ")" )
end

--[[---------------------------------------------
	team
-----------------------------------------------]]
function ATM.team( id )
	ATM.die( id )
end