--[[---------------------------------------------------------------------------
	
	Creator: x[N]ir - #4841
	This work is licensed under the Creative Commons 
	Attribution-NonCommercial-ShareAlike 4.0 International License. 
	License details: http://creativecommons.org/licenses/by-nc-sa/4.0/
	
-----------------------------------------------------------------------------]]

--[[---------------------------------------------
	MATH_dist
-----------------------------------------------]]
function ATM.MATH_dist( x1, y1, x2, y2 )
	return math.sqrt( ( y2 - y1 ) ^ 2 + ( x2 - x1 ) ^ 2 )
end

--[[---------------------------------------------
	MATH_inRect
-----------------------------------------------]]
function ATM.MATH_inRect( x, y, rx, ry, rw, rh )
	return ( x >= rx and x <= rx + rw ) and
		(y >= ry and y <= ry + rh)
end